## org.eclipse.ocl.expressions
Interface MessageExp<C,COA,SSA>

All Superinterfaces:
  ASTNode, CallingASTNode, EObject, Notifier, OCLExpression<C>, TypedElement<C>, Visitable

All Known Subinterfaces:
  MessageExp, MessageExp

All Known Implementing Classes:
  MessageExpImpl, MessageExpImpl, MessageExpImpl

    public interface MessageExp<C,COA,SSA>

extends OCLExpression<C>, CallingASTNode

A representation of the model object 'Message Exp'.

The following features are supported:

- `Target`
- `Argument`
- `Called Operation`
- `Sent Signal`

See Also:
  `ExpressionsPackage.getMessageExp()`

Method Summary
`boolean` `checkHasOperationOrSignal(DiagnosticChain diagnostics, Map<Object,Object> context)` calledOperation->size() + sentSignal->size() = 1
`boolean` `checkOperationArguments(DiagnosticChain diagnostics, Map<Object,Object> context)` calledOperation->notEmpty() implies argument->forall (a | a.type.conformsTo (self.calledOperation.operation.ownedParameter-> select( kind = ParameterDirectionKind::in ) ->at (argument->indexOf (a)).type))
`boolean` `checkSignalArguments(DiagnosticChain diagnostics, Map<Object,Object> context)` sentSignal->notEmpty() implies argument->forall (a | a.type.conformsTo (self.sentSignal.signal.ownedAttribute ->at (argument->indexOf (a)).type))
`boolean` `checkTargetDefinesOperation(DiagnosticChain diagnostics, Map<Object,Object> context)` calledOperation->notEmpty() implies target.type.allOperations()->includes(calledOperation.operation)
`boolean` `checkTargetNotCollection(DiagnosticChain diagnostics, Map<Object,Object> context)` not target.type.oclIsKindOf(CollectionType)
`EList<OCLExpression<C>>` `getArgument()` Returns the value of the 'Argument' containment reference list.
`COA` `getCalledOperation()` Returns the value of the 'Called Operation' containment reference
`SSA` `getSentSignal()` Returns the value of the 'Sent Signal' containment reference
`OCLExpression<C>` `getTarget()` Returns the value of the 'Target' containment reference
`void` `setCalledOperation(COA value)` Sets the value of the '`Called Operation`' containment reference
`void` `setSentSignal(SSA value)` Sets the value of the '`Sent Signal`' containment reference
`void` `setTarget(OCLExpression<C> value)` Sets the value of the '`Target`' containment reference

Methods inherited from interface org.eclipse.ocl.utilities.TypedElement
`getName, getType, setName, setType`

Methods inherited from interface org.eclipse.emf.ecore.EObject
`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eIsProxy, eIsSet, eResource, eSet, eUnset`

Methods inherited from interface org.eclipse.emf.common.notify.Notifier
`eAdapters, eDeliver, eNotify, eSetDeliver`

Methods inherited from interface org.eclipse.ocl.utilities.Visitable
`accept`

Methods inherited from interface org.eclipse.emf.ecore.EObject
`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eIsProxy, eIsSet, eResource, eSet, eUnset`

Methods inherited from interface org.eclipse.emf.common.notify.Notifier
`eAdapters, eDeliver, eNotify, eSetDeliver`

Methods inherited from interface org.eclipse.ocl.utilities.ASTNode
`getEndPosition, getStartPosition, setEndPosition, setStartPosition`

Methods inherited from interface org.eclipse.emf.ecore.EObject
`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eIsProxy, eIsSet, eResource, eSet, eUnset`

Methods inherited from interface org.eclipse.emf.common.notify.Notifier
`eAdapters, eDeliver, eNotify, eSetDeliver`

Methods inherited from interface org.eclipse.ocl.utilities.CallingASTNode
`getPropertyEndPosition, getPropertyStartPosition, setPropertyEndPosition, setPropertyStartPosition`

Methods inherited from interface org.eclipse.ocl.utilities.ASTNode
`getEndPosition, getStartPosition, setEndPosition, setStartPosition`

Methods inherited from interface org.eclipse.emf.ecore.EObject
`eAllContents, eClass, eContainer, eContainingFeature, eContainmentFeature, eContents, eCrossReferences, eGet, eGet, eIsProxy, eIsSet, eResource, eSet, eUnset`

Methods inherited from interface org.eclipse.emf.common.notify.Notifier
`eAdapters, eDeliver, eNotify, eSetDeliver`

Method Detail

### getTarget

    OCLExpression<C> getTarget()

  Returns the value of the 'Target' containment reference.

  If the meaning of the 'Target' containment reference isn't clear, there really should be more of a description here...

  Returns:
    the value of the 'Target' containment reference.
  See Also:
    `setTarget(OCLExpression)`, `ExpressionsPackage.getMessageExp_Target()`

### setTarget

    void setTarget(OCLExpression<C> value)

  Sets the value of the '`Target`' containment reference.

  Parameters:
    `value` - the new value of the 'Target' containment reference.
  See Also:
    `getTarget()`

### getArgument

    EList<OCLExpression<C>> getArgument()

  Returns the value of the 'Argument' containment reference list. The list contents are of type `OCLExpression`<C>.

  If the meaning of the 'Argument' containment reference list isn't clear, there really should be more of a description here...

  Returns:
    the value of the 'Argument' containment reference list.
  See Also:
    `ExpressionsPackage.getMessageExp_Argument()`

### getCalledOperation

    COA getCalledOperation()

  Returns the value of the 'Called Operation' containment reference.

  If the meaning of the 'Called Operation' containment reference isn't clear, there really should be more of a description here...

  Returns:
    the value of the 'Called Operation' containment reference.
  See Also:
    `setCalledOperation(Object)`, `ExpressionsPackage.getMessageExp_CalledOperation()`

### setCalledOperation

    void setCalledOperation(COA value)

  Sets the value of the '`Called Operation`' containment reference.

  Parameters:
    `value` - the new value of the 'Called Operation' containment reference.
  See Also:
    `getCalledOperation()`

### getSentSignal

    SSA getSentSignal()

  Returns the value of the 'Sent Signal' containment reference.

  If the meaning of the 'Sent Signal' containment reference isn't clear, there really should be more of a description here...

  Returns:
    the value of the 'Sent Signal' containment reference.
  See Also:
    `setSentSignal(Object)`, `ExpressionsPackage.getMessageExp_SentSignal()`

### setSentSignal

    void setSentSignal(SSA value)

  Sets the value of the '`Sent Signal`' containment reference.

  Parameters:
    `value` - the new value of the 'Sent Signal' containment reference.
  See Also:
    `getSentSignal()`

### checkOperationArguments

    boolean checkOperationArguments(DiagnosticChain diagnostics,
                                    Map<Object,Object> context)

  calledOperation->notEmpty() implies argument->forall (a | a.type.conformsTo (self.calledOperation.operation.ownedParameter-> select( kind = ParameterDirectionKind::in ) ->at (argument->indexOf (a)).type))

  Parameters:
    `diagnostics` - The chain of diagnostics to which problems are to be appended.
    `context` - The cache of context-specific information.

### checkSignalArguments

    boolean checkSignalArguments(DiagnosticChain diagnostics,
                                 Map<Object,Object> context)

  sentSignal->notEmpty() implies argument->forall (a | a.type.conformsTo (self.sentSignal.signal.ownedAttribute ->at (argument->indexOf (a)).type))

  Parameters:
    `diagnostics` - The chain of diagnostics to which problems are to be appended.
    `context` - The cache of context-specific information.

### checkTargetDefinesOperation

    boolean checkTargetDefinesOperation(DiagnosticChain diagnostics,
                                        Map<Object,Object> context)

  calledOperation->notEmpty() implies target.type.allOperations()->includes(calledOperation.operation)

  Parameters:
    `diagnostics` - The chain of diagnostics to which problems are to be appended.
    `context` - The cache of context-specific information.

### checkHasOperationOrSignal

    boolean checkHasOperationOrSignal(DiagnosticChain diagnostics,
                                      Map<Object,Object> context)

  calledOperation->size() + sentSignal->size() = 1

  Parameters:
    `diagnostics` - The chain of diagnostics to which problems are to be appended.
    `context` - The cache of context-specific information.

### checkTargetNotCollection

    boolean checkTargetNotCollection(DiagnosticChain diagnostics,
                                     Map<Object,Object> context)

  not target.type.oclIsKindOf(CollectionType)

  Parameters:
    `diagnostics` - The chain of diagnostics to which problems are to be appended.
    `context` - The cache of context-specific information.

Copyright 2002, 2007 IBM Corporation and others. All Rights Reserved.